Index: /trunk/sources/HeuristicLab.Operators/3.3/Assigner.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/Assigner.cs	(revision 2773)
+++ /trunk/sources/HeuristicLab.Operators/3.3/Assigner.cs	(revision 2773)
@@ -0,0 +1,56 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Operators {
+  /// <summary>
+  /// An operator which clones and assigns the value of one parameter to another parameter.
+  /// </summary>
+  [Item("Assigner", "An operator which clones and assigns the value of one parameter to another parameter.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public sealed class Assigner : SingleSuccessorOperator {
+    public LookupParameter<IItem> LeftSideParameter {
+      get { return (LookupParameter<IItem>)Parameters["LeftSide"]; }
+    }
+    public ValueLookupParameter<IItem> RightSideParameter {
+      get { return (ValueLookupParameter<IItem>)Parameters["RightSide"]; }
+    }
+
+    public Assigner()
+      : base() {
+      Parameters.Add(new LookupParameter<IItem>("LeftSide", "The parameter whose value gets assigned with a clone of the other parameter's value."));
+      Parameters.Add(new ValueLookupParameter<IItem>("RightSide", "The parameter whose value is cloned and assigned to the value of the other parameter."));
+    }
+
+    public override IExecutionSequence Apply() {
+      LeftSideParameter.ActualValue = (IItem)RightSideParameter.ActualValue.Clone();
+      return base.Apply();
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Operators/3.3/CombinedOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/CombinedOperator.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/CombinedOperator.cs	(revision 2773)
@@ -68,5 +68,5 @@
     }
 
-    public override IExecutionContext Apply() {
+    public override IExecutionSequence Apply() {
       ExecutionContextCollection next = new ExecutionContextCollection(base.Apply());
       if (operatorGraph.InitialOperator != null)
Index: /trunk/sources/HeuristicLab.Operators/3.3/Comparator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/Comparator.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/Comparator.cs	(revision 2773)
@@ -61,5 +61,5 @@
     }
 
-    public override IExecutionContext Apply() {
+    public override IExecutionSequence Apply() {
       IItem left = LeftSideParameter.ActualValue;
       IItem right = RightSideParameter.ActualValue;
Index: /trunk/sources/HeuristicLab.Operators/3.3/ConditionalBranch.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/ConditionalBranch.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/ConditionalBranch.cs	(revision 2773)
@@ -62,5 +62,5 @@
     }
 
-    public override IExecutionContext Apply() {
+    public override IExecutionSequence Apply() {
       ExecutionContextCollection next = new ExecutionContextCollection(base.Apply());
       if (ConditionParameter.ActualValue.Value) {
Index: /trunk/sources/HeuristicLab.Operators/3.3/DoubleCounter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/DoubleCounter.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/DoubleCounter.cs	(revision 2773)
@@ -30,5 +30,5 @@
 namespace HeuristicLab.Operators {
   /// <summary>
-  /// Operator which increments a double variable.
+  /// An operator which increments a double variable.
   /// </summary>
   [Item("DoubleCounter", "An operator which increments a double variable.")]
@@ -53,5 +53,5 @@
     }
 
-    public override IExecutionContext Apply() {
+    public override IExecutionSequence Apply() {
       if (ValueParameter.ActualValue == null) ValueParameter.ActualValue = new DoubleData();
       ValueParameter.ActualValue.Value += IncrementParameter.ActualValue.Value;
Index: /trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 2773)
@@ -89,14 +89,18 @@
     <Compile Include="ConditionalBranch.cs" />
     <Compile Include="Comparator.cs" />
+    <Compile Include="Assigner.cs" />
+    <Compile Include="MultipleCallsOperator.cs" />
+    <Compile Include="ParallelSubScopesProcessor.cs" />
+    <Compile Include="Placeholder.cs" />
+    <Compile Include="SingleCallOperator.cs" />
+    <Compile Include="IntCounter.cs" />
     <Compile Include="ScopeCleaner.cs" />
+    <Compile Include="SequentialSubScopesProcessor.cs" />
+    <Compile Include="StochasticBranch.cs" />
     <Compile Include="SubScopesRemover.cs" />
     <Compile Include="SubScopesSorter.cs" />
     <Compile Include="DoubleCounter.cs" />
-    <Compile Include="ParallelProcessor.cs" />
     <Compile Include="UniformParallelSubScopesProcessor.cs" />
     <Compile Include="UniformSequentialSubScopesProcessor.cs" />
-    <Compile Include="ValueCollector.cs" />
-    <Compile Include="MultipleSuccessorsOperator.cs" />
-    <Compile Include="Counter.cs" />
     <Compile Include="EmptyOperator.cs">
       <SubType>Code</SubType>
@@ -105,7 +109,7 @@
     <Compile Include="Operator.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="SequentialProcessor.cs" />
     <Compile Include="SingleSuccessorOperator.cs" />
     <Compile Include="SubScopesCreater.cs" />
+    <Compile Include="ValuesCollector.cs" />
     <Compile Include="VariableInjector.cs">
       <SubType>Code</SubType>
Index: /trunk/sources/HeuristicLab.Operators/3.3/IntCounter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/IntCounter.cs	(revision 2773)
+++ /trunk/sources/HeuristicLab.Operators/3.3/IntCounter.cs	(revision 2773)
@@ -0,0 +1,61 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Operators {
+  /// <summary>
+  /// An operator which increments an integer variable.
+  /// </summary>
+  [Item("IntCounter", "An operator which increments an integer variable.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public sealed class IntCounter : SingleSuccessorOperator {
+    public LookupParameter<IntData> ValueParameter {
+      get { return (LookupParameter<IntData>)Parameters["Value"]; }
+    }
+    public ValueLookupParameter<IntData> IncrementParameter {
+      get { return (ValueLookupParameter<IntData>)Parameters["Increment"]; }
+    }
+    public IntData Increment {
+      get { return IncrementParameter.Value; }
+      set { IncrementParameter.Value = value; }
+    }
+
+    public IntCounter()
+      : base() {
+      Parameters.Add(new LookupParameter<IntData>("Value", "The value which should be incremented."));
+      Parameters.Add(new ValueLookupParameter<IntData>("Increment", "The increment which is added to the value.", new IntData(1)));
+    }
+
+    public override IExecutionSequence Apply() {
+      if (ValueParameter.ActualValue == null) ValueParameter.ActualValue = new IntData();
+      ValueParameter.ActualValue.Value += IncrementParameter.ActualValue.Value;
+      return base.Apply();
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Operators/3.3/MultipleCallsOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/MultipleCallsOperator.cs	(revision 2773)
+++ /trunk/sources/HeuristicLab.Operators/3.3/MultipleCallsOperator.cs	(revision 2773)
@@ -0,0 +1,119 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Operators {
+  /// <summary>
+  /// An operator which applies multiple operators sequentially on the current scope.
+  /// </summary>
+  [Item("MultipleCallsOperator", "An operator which applies multiple operators sequentially on the current scope.")]
+  [Creatable("Test")]
+  public class MultipleCallsOperator : SingleSuccessorOperator {
+    protected IValueParameter<IOperator>[] OperatorParameters {
+      get {
+        return (from p in Parameters
+                where p is IValueParameter<IOperator>
+                where Operators.Contains(((IValueParameter<IOperator>)p).Value)
+                orderby p.Name ascending
+                select (IValueParameter<IOperator>)p).ToArray();
+      }
+    }
+
+    private OperatorList operators;
+    [Storable]
+    public OperatorList Operators {
+      get { return operators; }
+      private set {
+        operators = value;
+        operators.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<IOperator>>(operators_ItemsAdded);
+        operators.ItemsRemoved += new CollectionItemsChangedEventHandler<IndexedItem<IOperator>>(operators_ItemsRemoved);
+        operators.ItemsReplaced += new CollectionItemsChangedEventHandler<IndexedItem<IOperator>>(operators_ItemsReplaced);
+        operators.ItemsMoved += new CollectionItemsChangedEventHandler<IndexedItem<IOperator>>(operators_ItemsMoved);
+        operators.CollectionReset += new CollectionItemsChangedEventHandler<IndexedItem<IOperator>>(operators_CollectionReset);
+        var opParams = OperatorParameters;
+        foreach (IValueParameter<IOperator> opParam in opParams)
+          opParam.ValueChanged += new EventHandler(opParam_ValueChanged);
+      }
+    }
+
+    public MultipleCallsOperator()
+      : base() {
+      Operators = new OperatorList();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      MultipleCallsOperator clone = (MultipleCallsOperator)base.Clone(cloner);
+      clone.Operators = (OperatorList)cloner.Clone(operators);
+      return clone;
+    }
+
+    private void UpdateOperatorParameters() {
+      var opParams = OperatorParameters;
+      foreach (IValueParameter<IOperator> opParam in opParams) {
+        opParam.ValueChanged -= new EventHandler(opParam_ValueChanged);
+        Parameters.Remove(opParam.Name);
+      }
+      for (int i = 0; i < Operators.Count; i++) {
+        IValueParameter<IOperator> opParam = new OperatorParameter(i.ToString(), string.Empty, Operators[i]);
+        opParam.ValueChanged += new EventHandler(opParam_ValueChanged);
+        Parameters.Add(opParam);
+      }
+    }
+    private void operators_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<IOperator>> e) {
+      UpdateOperatorParameters();
+    }
+    private void operators_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<IOperator>> e) {
+      UpdateOperatorParameters();
+    }
+    private void operators_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<IndexedItem<IOperator>> e) {
+      foreach (IndexedItem<IOperator> item in e.Items)
+        ((IValueParameter<IOperator>)Parameters[item.Index.ToString()]).Value = item.Value;
+    }
+    private void operators_ItemsMoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<IOperator>> e) {
+      foreach (IndexedItem<IOperator> item in e.Items)
+        ((IValueParameter<IOperator>)Parameters[item.Index.ToString()]).Value = item.Value;
+    }
+    private void operators_CollectionReset(object sender, CollectionItemsChangedEventArgs<IndexedItem<IOperator>> e) {
+      UpdateOperatorParameters();
+    }
+    private void opParam_ValueChanged(object sender, EventArgs e) {
+      IValueParameter<IOperator> opParam = (IValueParameter<IOperator>)sender;
+      int index = int.Parse(opParam.Name);
+      operators[index] = opParam.Value;
+    }
+
+    public override IExecutionSequence Apply() {
+      ExecutionContextCollection next = new ExecutionContextCollection(base.Apply());
+      for (int i = Operators.Count - 1; i >= 0; i--)
+        next.Insert(0, new ExecutionContext(ExecutionContext.Parent, Operators[i], ExecutionContext.Scope));
+      return next;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Operators/3.3/Operator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/Operator.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/Operator.cs	(revision 2773)
@@ -130,5 +130,5 @@
 
     /// <inheritdoc/>
-    public virtual IExecutionContext Execute(ExecutionContext context) {
+    public virtual IExecutionSequence Execute(ExecutionContext context) {
       try {
         Canceled = false;
@@ -136,5 +136,5 @@
         foreach (IParameter param in Parameters)
           param.ExecutionContext = context;
-        IExecutionContext next = Apply();
+        IExecutionSequence next = Apply();
         OnExecuted();
         return next;
@@ -156,5 +156,5 @@
     /// <param name="scope">The scope where to execute the operator</param>
     /// <returns><c>null</c>.</returns>
-    public abstract IExecutionContext Apply();
+    public abstract IExecutionSequence Apply();
 
     protected virtual void OnExecutionContextChanged() { }
Index: /trunk/sources/HeuristicLab.Operators/3.3/ParallelSubScopesProcessor.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/ParallelSubScopesProcessor.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/ParallelSubScopesProcessor.cs	(revision 2773)
@@ -22,29 +22,32 @@
 using System;
 using System.Collections.Generic;
+using System.Linq;
 using System.Text;
+using System.Xml;
+using HeuristicLab.Collections;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Operators {
   /// <summary>
-  /// Performs <c>n</c> operators on <c>n</c> subscopes, operations can be executed in parallel.
+  /// An operator which contains multiple operators of which each is applied in parallel on one sub-scope of the current scope. The first operator is applied on the first sub-scope, the second on the second, and so on.
   /// </summary>
-  public class ParallelSubScopesProcessor : OperatorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
+  [Item("ParallelSubScopesProcessor", "An operator which contains multiple operators of which each is applied in parallel on one sub-scope of the current scope. The first operator is applied on the first sub-scope, the second on the second, and so on.")]
+  [Creatable("Test")]
+  public sealed class ParallelSubScopesProcessor : MultipleCallsOperator {
+    public ParallelSubScopesProcessor()
+      : base() {
     }
 
-    /// <summary>
-    /// Applies <c>n</c> operators on all the <c>n</c> sub scopes of the given <paramref name="scope"/>.
-    /// </summary>
-    /// <param name="scope">The scope on whose sub scopes the operators are applied.</param>
-    /// <returns>A new <see cref="CompositeOperation"/> with the <c>i</c>th operator applied
-    /// on the <c>i</c>th sub scope, the <c>ExecuteInParallel</c> flag set to <c>true</c>.</returns>
-    public override IOperation Apply(IScope scope) {
-      CompositeOperation next = new CompositeOperation();
-      next.ExecuteInParallel = true;
-      for (int i = 0; i < scope.SubScopes.Count; i++)
-        next.AddOperation(new AtomicOperation(SubOperators[i], scope.SubScopes[i]));
+    public override IExecutionSequence Apply() {
+      ExecutionContextCollection next = new ExecutionContextCollection(base.Apply());
+      if (Operators.Count > 0) {
+        ExecutionContextCollection inner = new ExecutionContextCollection();
+        inner.Parallel = true;
+        for (int i = 0; (i < ExecutionContext.Scope.SubScopes.Count) && (i < Operators.Count); i++)
+          inner.Add(new ExecutionContext(ExecutionContext.Parent, Operators[i], ExecutionContext.Scope.SubScopes[i]));
+        next.Insert(0, inner);
+      }
       return next;
     }
Index: /trunk/sources/HeuristicLab.Operators/3.3/Placeholder.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/Placeholder.cs	(revision 2773)
+++ /trunk/sources/HeuristicLab.Operators/3.3/Placeholder.cs	(revision 2773)
@@ -0,0 +1,55 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Operators {
+  /// <summary>
+  /// An operator which acts as a placeholder for another operator retrieved from the scope or a parent execution context.
+  /// </summary>
+  [Item("Placeholder", "An operator which acts as a placeholder for another operator retrieved from the scope or a parent execution context.")]
+  [Creatable("Test")]
+  [EmptyStorableClass]
+  public sealed class Placeholder : SingleSuccessorOperator {
+    public LookupParameter<IOperator> OperatorParameter {
+      get { return (LookupParameter<IOperator>)Parameters["Operator"]; }
+    }
+
+    public Placeholder()
+      : base() {
+      Parameters.Add(new LookupParameter<IOperator>("Operator", "The operator which is retrieved from the scope or a parent execution context and applied on the current scope."));
+    }
+
+    public override IExecutionSequence Apply() {
+      ExecutionContextCollection next = new ExecutionContextCollection(base.Apply());
+      IOperator op = OperatorParameter.ActualValue;
+      if (op != null)
+        next.Insert(0, new ExecutionContext(ExecutionContext.Parent, op, ExecutionContext.Scope));
+      return next;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Operators/3.3/ScopeCleaner.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/ScopeCleaner.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/ScopeCleaner.cs	(revision 2773)
@@ -47,5 +47,5 @@
     }
 
-    public override IExecutionContext Apply() {
+    public override IExecutionSequence Apply() {
       CurrentScope.Variables.Clear();
       CurrentScope.SubScopes.Clear();
Index: /trunk/sources/HeuristicLab.Operators/3.3/SequentialSubScopesProcessor.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/SequentialSubScopesProcessor.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/SequentialSubScopesProcessor.cs	(revision 2773)
@@ -22,28 +22,31 @@
 using System;
 using System.Collections.Generic;
+using System.Linq;
 using System.Text;
+using System.Xml;
+using HeuristicLab.Collections;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Operators {
   /// <summary>
-  /// Performs <c>n</c> operators on <c>n</c> subscopes, operations must be executed sequentially.
+  /// An operator which contains multiple operators of which each is applied sequentially on one sub-scope of the current scope. The first operator is applied on the first sub-scope, the second on the second, and so on.
   /// </summary>
-  public class SequentialSubScopesProcessor : OperatorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
+  [Item("SequentialSubScopesProcessor", "An operator which contains multiple operators of which each is applied sequentially on one sub-scope of the current scope. The first operator is applied on the first sub-scope, the second on the second, and so on.")]
+  [Creatable("Test")]
+  public sealed class SequentialSubScopesProcessor : MultipleCallsOperator {
+    public SequentialSubScopesProcessor()
+      : base() {
     }
 
-    /// <summary>
-    /// Applies <c>n</c> operators on all the <c>n</c> sub scopes of the given <paramref name="scope"/>.
-    /// </summary>
-    /// <param name="scope">The scope on whose sub scopes the operators are applied.</param>
-    /// <returns>A new <see cref="CompositeOperation"/> with the <c>i</c>th operator applied
-    /// on the <c>i</c>th sub scope.</returns>
-    public override IOperation Apply(IScope scope) {
-      CompositeOperation next = new CompositeOperation();
-      for (int i = 0; i < scope.SubScopes.Count; i++)
-        next.AddOperation(new AtomicOperation(SubOperators[i], scope.SubScopes[i]));
+    public override IExecutionSequence Apply() {
+      ExecutionContextCollection next = new ExecutionContextCollection(base.Apply());
+      if (Operators.Count > 0) {
+        ExecutionContextCollection inner = new ExecutionContextCollection();
+        for (int i = 0; (i < ExecutionContext.Scope.SubScopes.Count) && (i < Operators.Count); i++)
+          inner.Add(new ExecutionContext(ExecutionContext.Parent, Operators[i], ExecutionContext.Scope.SubScopes[i]));
+        next.Insert(0, inner);
+      }
       return next;
     }
Index: /trunk/sources/HeuristicLab.Operators/3.3/SingleCallOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/SingleCallOperator.cs	(revision 2773)
+++ /trunk/sources/HeuristicLab.Operators/3.3/SingleCallOperator.cs	(revision 2773)
@@ -0,0 +1,58 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Operators {
+  /// <summary>
+  /// An operator which applies a specified operator on the current scope.
+  /// </summary>
+  [Item("SingleCallOperator", "An operator which applies a specified operator on the current scope.")]
+  [Creatable("Test")]
+  [EmptyStorableClass]
+  public class SingleCallOperator : SingleSuccessorOperator {
+    protected OperatorParameter OperatorParameter {
+      get { return (OperatorParameter)Parameters["Operator"]; }
+    }
+    public IOperator Operator {
+      get { return OperatorParameter.Value; }
+      set { OperatorParameter.Value = value; }
+    }
+
+    public SingleCallOperator()
+      : base() {
+      Parameters.Add(new OperatorParameter("Operator", "The operator which should be applied on the current scope."));
+    }
+
+    public override IExecutionSequence Apply() {
+      ExecutionContextCollection next = new ExecutionContextCollection(base.Apply());
+      if (Operator != null)
+        next.Insert(0, new ExecutionContext(ExecutionContext.Parent, Operator, ExecutionContext.Scope));
+      return next;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Operators/3.3/SingleSuccessorOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/SingleSuccessorOperator.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/SingleSuccessorOperator.cs	(revision 2773)
@@ -49,5 +49,5 @@
     }
 
-    public override IExecutionContext Apply() {
+    public override IExecutionSequence Apply() {
       if (Successor != null)
         return new ExecutionContext(ExecutionContext.Parent, Successor, ExecutionContext.Scope);
